## libheinz 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15 FATAL_ERROR)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(PreventInSourceBuilds)

project(LibHeinz VERSION 2.0.0 LANGUAGES CXX)

## Options.

if(NOT DEFINED BUILD_SHARED_LIBS)
    option(BUILD_SHARED_LIBS "Build as shared library" ON)
endif()
option(PEDANTIC "Compile with pedantic warnings" ON)
option(WERROR "Treat warnings as errors" OFF)

## Compiler settings.

set(CMAKE_CXX_STANDARD 17)
add_compile_options(-O2)
if(WIN32)
    set(WINDOWS_EXPORT_ALL_SYMBOLS ON)
    message(STATUS "compiling for Windows")
else()
    add_compile_options(-Wall -Wno-unknown-pragmas)
    if(PEDANTIC)
        add_compile_options(-pedantic)
    endif()
endif()
if(WERROR)
    add_compile_options(-Werror)
endif()

## Subdirectories.

include(CTest)

add_subdirectory(inc)
add_subdirectory(test)

## CPack settings.

include(InstallRequiredSystemLibraries)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_VERSION_MAJOR "${LibHeinz_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${LibHeinz_VERSION_MINOR}")
set(CPACK_SOURCE_GENERATOR "TGZ")
include(CPack)
include(CMakePackageConfigHelpers)
export(PACKAGE LibHeinz)

## Config files.

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/LibHeinzConfig.cmake"
    INSTALL_DESTINATION "lib/cmake/example"
    NO_SET_AND_CHECK_MACRO
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
    )

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/LibHeinzConfigVersion.cmake"
    VERSION "${LibHeinz_VERSION}"
    COMPATIBILITY AnyNewerVersion
    )

install(FILES
    "${PROJECT_BINARY_DIR}/LibHeinzConfig.cmake"
    "${PROJECT_BINARY_DIR}/LibHeinzConfigVersion.cmake"
    DESTINATION cmake COMPONENT dev)

=== inc/CMakeLists.txt ===
set(api_files heinz/Complex.h heinz/Vectors3D.h heinz/Rotations3D.h)

install(
    FILES ${api_files}
    DESTINATION include/heinz
    COMPONENT Headers)

=== test/CMakeLists.txt ===
file(GLOB test_sources "*Test.cpp")

if (WIN32)
    add_compile_options(/wd4068 /wd4623 /wd4625 /wd4626 /wd4710 /wd4711 /wd4820 )
endif()

foreach(source_file ${test_sources})
    get_filename_component(base_name ${source_file} NAME_WE)
    add_executable(${base_name} ${source_file} catch2.cpp)
    target_include_directories(${base_name}
        PRIVATE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/inc)
    add_test(NAME ${base_name} COMMAND ${base_name})
endforeach(source_file)

=== debian/changelog ===
libheinz (2.0.0-3) unstable; urgency=medium

  * Backport commit 7fbc645d from upstream Git.

 -- Roland Mas <lolando@debian.org>  Thu, 09 May 2024 22:52:01 +0200

libheinz (2.0.0-2) unstable; urgency=medium

  * Update debian/watch.

 -- Roland Mas <lolando@debian.org>  Sun, 15 Oct 2023 16:48:54 +0200

libheinz (2.0.0-1) unstable; urgency=medium

  * Initial release.

 -- Roland Mas <lolando@debian.org>  Wed, 26 Jul 2023 00:10:17 +0200

=== debian/control ===
Source: libheinz
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Roland Mas <lolando@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.6.2
Homepage: https://jugit.fz-juelich.de/mlz/libheinz
Vcs-Browser: https://salsa.debian.org/science-team/libheinz
Vcs-Git: https://salsa.debian.org/science-team/libheinz.git

Package: libheinz-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: C++ base library of Heinz Maier-Leibnitz Zentrum
 C++ base library used by other projects by Heinz Maier-Leibnitz
 Zentrum, in particular bornagain.
